
	
 xdef _tt_Get8Bit
_tt_Get8Bit:
    lea     _tt_InBuffer,a0
    movea.l (a0),a1           ; address of current byte */
    clr.w   d0
    move.b  (a1)+,d0          ; anyway,read first byte */
    move.l  a1,(a0)           ; and increment pointer */
    move.w  _tt_InMask,d1
    cmpi.b  #$80,d1
    bne.s   __inl_tries
    rts
__inl_tries:
    lsl.w   #8,d0              ; v = *(_tt_InBuffer++) << 8; */
    move.b  (a1),d0           ; v |= *_tt_InBuffer; */
    ; bra.s    try08 */
    cmpi.b  #$08,d1
    bhi.s   __inl_try20
    bne.s   __inl_try02
    andi.w  #$0fff,d0
    lsr.w   #4,d0
    rts
__inl_try40:
    andi.w  #$7fff,d0
    lsr.w   #7,d0
    rts
__inl_try20:
    cmpi.b  #$20,d1
    bhi.s   __inl_try40
    bcs.s   __inl_try10
    andi.w  #$3fff,d0
    lsr.w   #6,d0
    rts
__inl_try10:
    andi.w  #$1fff,d0
    lsr.w   #5,d0
    rts
__inl_try04:
    andi.w  #$07ff,d0
    lsr.w   #3,d0
    rts
__inl_try02:
    cmpi.b  #$02,d1
    bhi.s   __inl_try04
    bne.s   __inl_try01
    andi.w  #$03ff,d0
    lsr.w   #2,d0
    rts
__inl_try01:
    andi.w  #$01ff,d0
    lsr.w   #1,d0
    rts
	
	
 xdef _tt_GetValue
_tt_GetValue:
    move.l  d3,-(sp)
    clr.l   d1                 ; i */
    move.w  8(sp),d0          ; maxgamma */
    move.l  _tt_InBuffer,a0
    move.w  _tt_InMask,d2
__inl_loop1:
    cmp.w   d1,d0
    bls.s   __inl_exitloop
    ; !(*_tt_InBuffer & _tt_InMask) */
    move.w  d2,d3
    and.b   (a0),d3
    ; if (!(_tt_InMask >>= 1)) _tt_InMask = 0x80,_tt_InBuffer++; */
    ror.b   #1,d2          ; thx tom for the ror with carry trick ;) */
    bcc.s   __inl_samebyte1
    addq.l  #1,a0
__inl_samebyte1:
    ; test if next bit set only now */
    tst.b   d3
    beq.s   __inl_exitloop
    addq.w  #1,d1
    bra.s   __inl_loop1
__inl_exitloop:
    move.l  a0,_tt_InBuffer
    move.w  d2,_tt_InMask
    moveq   #1,d3
    lsl.w   d1,d3
    move.w  d1,-(sp)
    bsr.s       _tt_GetBits
    addq    #2,sp
    or.w    d3,d0
    move.l  (sp)+,d3
    rts
	
	
 xdef _tt_GetBits
_tt_GetBits:
    clr.w   d0
    move.w  4(sp),d1
    beq.s   __inl_exit          ; just in case ;) */
    movea.l _tt_InBuffer,a0    ; _tt_InBuffer,gcc makes it pc relative :) */
    movea.l d3,a1             ; use a1 to save d3: 4 cycles better than move.w d3,-(sp) */
    move.w  _tt_InMask,d2      ; pc relative too :)) */
    subq.w  #1,d1
__inl_loop0:
    lsl.w   #1,d0
    ; (*_tt_InBuffer & _tt_InMask) */
    move.w  d2,d3
    and.b   (a0),d3
    beq.s   __inl_correct0
    addq.b  #1,d0          ; here,bit #0 of d0 is never set :) it's a four cycles gain :)) */
__inl_correct0:
    ; if (!(_tt_InMask >>= 1)) _tt_InMask = 0x80,_tt_InBuffer++; */
    ror.b   #1,d2
    bcc.s   __inl_samebyte0
    addq.l  #1,a0
__inl_samebyte0:
    dbra    d1,__inl_loop0
    move.w  d2,_tt_InMask      ; saves _tt_InMask */
    move.l  a1,d3             ; restores d3 (4 cycles again :) */
    move.l  a0,_tt_InBuffer    ; saves _tt_InBuffer */
__inl_exit:
    rts

	
	 EVEN
	 xdef	_tt_Decompress
_tt_Decompress:
	lea -12(sp),sp
	movem.l #$1f3e,-(sp)
	cmp.b #84,2(a0)
	bne LUnpack2
	cmp.b #80,3(a0)
	bne LUnpack2
	moveq #0,d4
	move.b 6(a0),d4
	move.b 9(a0),42(sp)
	clr.w d0
	move.b 42(sp),d0
	move.w d0,a4
	clr.w d5
	move.b 10(a0),d5
	subq.w #1,d5
	move.b 12(a0),43(sp)
	clr.w d1
	move.b 43(sp),d1
	move.w d1,a6
	moveq #1,d1
	lsl.w d5,d1
	moveq #2,d2
	lsl.w d5,d2
	move.w d2,48(sp)
	moveq #8,d0
	sub.w d5,d0
	move.w d0,50(sp)
	moveq #8,d7
	sub.w a4,d7
	move.w #249,d0
	moveq #8,d2
	cmp.w a4,d2
	bcs LUnpack7
	clr.w d0
	move.b 11(a0),d0
	move.w d0,a5
	cmp.w a5,d1
	bne LUnpack8
	cmp.w #4,d5
	bls LUnpack8
	cmp.w #7,d5
	bhi LUnpack8
	move.w #251,d0
	moveq #4,d1
	cmp.w a6,d1
	bcs LUnpack7
	lea 15(a0),a2
	move.l a2,44(sp)
	moveq #0,d0
	move.b (a2),d0
	lea 16(a0,d0.l),a0
	move.l a0,_tt_InBuffer
	move.w #128,_tt_InMask
	bra LUnpack44
LUnpack15:
	move.l d6,d4
LUnpack44:
	move.l a1,a3
	move.w d4,d3
	tst.b 42(sp)
	beq LUnpack16
	move.w a4,-(sp)
	jsr _tt_GetBits
	move.w d0,d3
	addq.l #2,sp
LUnpack16:
	move.w d3,d6
	ext.l d6
	cmp.l d6,d4
	bne LUnpack18
	move.w d5,-(sp)
	lea _tt_GetValue,a2
	jsr (a2)
	move.w d0,d4
	addq.l #2,sp
	cmp.w #1,d0
	beq LUnpack20
	move.w d5,-(sp)
	jsr (a2)
	move.w d0,d3
	subq.w #1,d3
	move.w 50(sp),d0
	subq.w #2,d0
	addq.l #2,sp
	cmp.w d3,d0
	bne LUnpack22
	cmp.w #3,d4
	bls LUnpack41
	lea _tt_Get8Bit,a2
	jsr (a2)
	move.w d0,d3
	jsr (a2)
	move.w d0,d1
	eor.w #255,d1
	bra LUnpack26
LUnpack22:
	tst.b 43(sp)
	beq LUnpack27
	move.w a6,-(sp)
	jsr _tt_GetBits
	move.w a6,d1
	lsl.w d1,d3
	or.w d0,d3
	addq.l #2,sp
LUnpack27:
	jsr _tt_Get8Bit
	move.w d3,d1
	lsl.w #8,d1
	eor.w #255,d0
	or.w d0,d1
	bra LUnpack45
LUnpack20:
	move.l _tt_InBuffer,a0
	move.w _tt_InMask,d1
	clr.w d0
	move.b (a0),d0
	and.w d1,d0
	beq LUnpack29

	ror.b  #1,d1
	bcc.s  __inl_tt_cim_skip0
	addq.l #1,a0
__inl_tt_cim_skip0:

	move.l a0,_tt_InBuffer
	move.w d1,_tt_InMask
	clr.w d0
	move.b (a0),d0
	and.w d1,d0
	bne LUnpack31
	move.w d1,d0

	ror.b  #1,d0
	bcc.s  __inl_tt_cim_skip1
	addq.l #1,a0
__inl_tt_cim_skip1:

	move.l a0,_tt_InBuffer
	move.w d0,_tt_InMask
	move.w a4,-(sp)
	lea _tt_GetBits,a2
	jsr (a2)
	move.w d0,d3
	move.w d7,-(sp)
	jsr (a2)
	move.w d7,d1
	ext.l d1
	lsl.l d1,d6
	or.b d6,d0
	move.b d0,(a3)+
	move.l a3,a1
	moveq #0,d6
	move.w d3,d6
	addq.l #4,sp
	bra LUnpack15
LUnpack31:
	move.w d1,d0

	ror.b  #1,d0
	bcc.s  __inl_tt_cim_skip2
	addq.l #1,a0
__inl_tt_cim_skip2:

	move.l a0,_tt_InBuffer
	move.w d0,_tt_InMask
	move.w d5,-(sp)
	jsr (a2)
	move.w d0,d4
	addq.l #2,sp
	cmp.w a5,d0
	bcs LUnpack33
	move.w 50(sp),-(sp)
	jsr _tt_GetBits
	sub.w a5,d4
	move.w 52(sp),d2
	lsl.w d2,d4
	or.w d0,d4
	move.w d5,-(sp)
	jsr (a2)
	subq.w #1,d0
	lsl.w #8,d0
	or.w d0,d4
	addq.l #4,sp
LUnpack33:
	move.w d5,-(sp)
	jsr (a2)
	move.w d0,d3
	addq.l #2,sp
	cmp.w #31,d0
	bhi LUnpack35
	moveq #0,d0
	move.w d3,d0
	move.l 44(sp),a0
	move.b 0(a0,d0.l),d1
	ext.w d1
	bra LUnpack37
LUnpack35:
	move.w #3,-(sp)
	jsr _tt_GetBits
	move.w d3,d1
	add.w #-32,d1
	lsl.w #3,d1
	or.w d0,d1
	addq.l #2,sp
LUnpack37:
	move.l a3,a1
LUnpack38:
	move.b d1,(a1)+
	move.w a1,d0
	sub.w a3,d0
	cmp.w d0,d4
	bcs LUnpack15
	bra LUnpack38
LUnpack29:
	move.w d1,d0

	ror.b  #1,d0
	bcc.s  __inl_tt_cim_skip3
	addq.l #1,a0
__inl_tt_cim_skip3:

	move.l a0,_tt_InBuffer
	move.w d0,_tt_InMask
	jsr _tt_Get8Bit
	move.w d0,d1
	eor.w #255,d1
LUnpack45:
	clr.w d3
LUnpack26:
	moveq #0,d0
	move.w d1,d0
	move.l a3,a0
	sub.l d0,a0
	subq.l #1,a0
	move.l a3,a1
LUnpack39:
	move.b (a0)+,d0
	add.b d3,d0
	move.b d0,(a1)+
	move.w a1,d0
	sub.w a3,d0
	cmp.w d0,d4
	bcs LUnpack15
	bra LUnpack39
LUnpack18:
	move.w d7,-(sp)
	jsr _tt_GetBits
	lsl.w d7,d3
	or.b d3,d0
	move.b d0,(a3)+
	move.l a3,a1
	move.l d4,d6
	addq.l #2,sp
	bra LUnpack15
LUnpack2:
	move.w #252,d0
	bra LUnpack7
LUnpack41:
	clr.w d0
	bra LUnpack7
LUnpack8:
	move.w #250,d0
LUnpack7:
	movem.l (sp)+,#$7cf8
	lea 12(sp),sp
	rts
